;  200   PIC16F628A v.5
;05/11/2012
;
;!!!   ICprog 1.05   PIC16F628!!!
;
;  
;       
; 0 ( 1:2)   Flag,  
;      2   0.
;     PHASE,  FA, FB, FC
;    RB0/pin6   . 
;
;--------------------------------------------------------------
	list p=16f628
	__CONFIG _WDT_OFF & _INTRC_OSC_NOCLKOUT & _BODEN_OFF & _MCLRE_ON & _CP_OFF & _DATA_CP_OFF & _LVP_OFF
	errorlevel -302

	#include p16f628.inc
	#include gen3x200.h
;**************************************************************
	org	0
	goto	INIT
;==============================================================
;    
;==============================================================
	org	0x0004
ISR_START			; /   TMR0
	movwf	W_TEMP		; 
	swapf	STATUS,W
	clrf	STATUS		
	movwf	STATUS_TEMP
	movf	PCLATH,W
	movwf	PCLATH_TEMP
	clrf	PCLATH
;
	btfsc	INTCON,INTF	;  ?
	goto	STOP_WORK	; ,  
	btfsc	INTCON,T0IF	;   0?
	goto	INT_TMR0	; 
ISR_FINISH
	movf	PCLATH_TEMP,W	; 
	movwf	PCLATH
	swapf	STATUS_TEMP,W
	movwf	STATUS
	swapf	W_TEMP,F
	swapf	W_TEMP,W
	retfie
INT_TMR0		;    0
	movlw	k_T0
	movwf	TMR0		; TMR0
	bcf	INTCON,T0IF	;  
	btfss	Flag,0		;  ,    
	goto	DO_JOB		;     
	bcf	Flag,0	;      
	goto	ISR_FINISH
DO_JOB
	bsf	Flag,0
	call	CHANGE_PHASE	; /   
	goto	ISR_FINISH
STOP_WORK
	clrf	PORTB	;  
	Ahi_OFF
	Bhi_OFF
	Chi_OFF
	clrf	INTCON	;  
	bsf	LED	;   
waiting_for_reset
	goto	waiting_for_reset	;  
;
;==============================================================
;		             
;==============================================================
	org	0x0080
INIT
	clrf	PORTA
	clrf	PORTB
;
	BANK1
	movlw	b'11000000'	; ,..0
	movwf	OPTION_REG	; T0=1/2
	clrf	INTCON		;  
	clrf	PIE1		;  
	movlw	b'00100000'	;RA5-input, other - output
	movwf	TRISA
	movlw	b'00000001'	;RB1-7 - output; RB0-input
	movwf	TRISB
	BANK0
;==============================================================
START_JOB
	clrf	TMR0		;  0
	movlw	b'00110000'	;   .
	movwf	INTCON		;    
	bsf	INTCON,GIE	; 

;        "0"
	movlw	k_T0
	movwf	TMR0		; TMR0
	bcf	INTCON,T0IF	;  
;
	clrf	COUNTER		;  
	bsf	COUNTER,1	;   "1"
	clrf	Flag	;   
;   "0"
	Alo_OFF
	Clo_OFF
	Bhi_OFF
	Ahi_ON
	Chi_ON
	Blo_ON
;  ,      0 ( INT)
LOOP
	goto	LOOP 
	goto	LOOP
	goto	LOOP
;==============================================================
;==============================================================
;* S U B R O U T I N E S ** S U B R O U T I N E S ** S U B J S 
;==============================================================
;   
;==============================================================\
CHANGE_PHASE
;
;         
;  .    6 ,  
;   0-5   COUNTER.
search_position
	btfsc	COUNTER,0
	goto	POS_0	
	btfsc	COUNTER,1
	goto	POS_1	
	btfsc	COUNTER,2
	goto	POS_2	
	btfsc	COUNTER,3
	goto	POS_3
	btfsc	COUNTER,4
	goto	POS_4
	btfsc	COUNTER,5
	goto	POS_5
	goto	INIT	;,  
;
POS_0			;    -+
	clrf	COUNTER
	bsf	COUNTER,1	;   
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	Alo_OFF
	call	PAUSE
	Ahi_ON
	RETLW	0
POS_1			;    +-
	clrf	COUNTER
	bsf	COUNTER,2	;  
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	Chi_OFF
	call	PAUSE
	Clo_ON
	RETLW	0
POS_2			;  B  -+
	clrf	COUNTER
	bsf	COUNTER,3	;  
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	Blo_OFF
	call	PAUSE
	Bhi_ON
	RETLW	0
POS_3			;  A  +-
	clrf	COUNTER
	bsf	COUNTER,4	;   
	NOP
	NOP
	NOP
	NOP
	Ahi_OFF
	call	PAUSE
	Alo_ON
	RETLW	0
POS_4			;  C  -+
	clrf	COUNTER
	bsf	COUNTER,5	;  
	NOP
	NOP
	Clo_OFF
	call	PAUSE
	Chi_ON
	RETLW	0
POS_5			;  B  +-
	clrf	COUNTER
	bsf	COUNTER,0	;  
	Bhi_OFF
	call	PAUSE
	Blo_ON
	RETLW	0
;==============================================================/
;==============================================================
;  
;==============================================================
;--------------------------------------------------------------
;  
;--------------------------------------------------------------
PAUSE	
;	movlw	.12	;38us
	movlw	.16	;50us
;	movlw	.32	;100us
	movwf	LSD
uP_loop	decfsz	LSD,F
	goto	uP_loop
	RETLW	0
;==============================================================
;--------------------------------------------------------------
	END

